#ifndef ADC_H
#define	ADC_H
//------------------------------------------------------------------------------
#include "ADC_Prototypes.h"
//------------------------------------------------------------------------------
void ADC_init()
{  
  ADCON0 = 0xC1; //FRC (clock derived from a dedicated internal oscillator = 500 kHz max),<CHS3:CHS0>Channel 0 (AN0),(ADON) A/D converter module is powered up
  ADCON1 = 0x80; //ADFM = 1 (Right justified. Six (6) Most Significant bits of ADRESH are read as 0)
}
//------------------------------------------------------------------------------
void ADC_channelSelect(unsigned char channel)
{
  char chl = (channel <= MAX_CHANNELS) ? channel : 0; //If Invalid channel is provided default to channel 0 
  ADCON0 =  ADCON0 | (chl<<2);                        //Set the required channel select Bits: CHS3 CHS2 CHS1 CHS0
}
//------------------------------------------------------------------------------
int ADC_read(unsigned char channel)
{ 
  ADC_channelSelect(channel);  
  ADC_conversion();

  return ((ADRESH<<8)+(ADRESL));
}
//------------------------------------------------------------------------------
void ADC_conversion()
{
  __delay_ms(1);                                     //Conversion time
  GO_DONE = 1;
  while(GO_DONE);                                    //wait for ADC completion
}
//------------------------------------------------------------------------------
float ADC_toFloat(int num)
{
  const float resl = (5.0/1024); //ADC Resolution
  float result = num * resl;  
  
  return (result * 1000);
}
//------------------------------------------------------------------------------
#endif